<?php
/* calendar
	name : calendar
	released: 2014/10/04
*/

function calendar( $arg )
{
	global $params,$ut,$html;
	$arg = func_get_args();
	$ut->get_arg($arg);
	$arg['tpltag'] = true;
	return frame_renderer(_calendar_renderer($params['page'], $arg));
}
function calendar_renderer( &$page_ar )
{
	global $params,$ut,$html;
	$arg = array();
	return frame_renderer(_calendar_renderer($page_ar, $arg));
}
function _calendar_renderer( &$page_ar , &$arg )
{
	global $params,$ut,$html;
	if (!empty($page_ar['meta']['plugin_calendar_grid'])) {
		$arg['grid'] = $page_ar['meta']['plugin_calendar_grid'];
	}
	if (!empty($arg['grid'])) {
		$arg['full-row'] = true;
		$opt = array(
			'2'=>array('50','290')
			, '3'=>array('33.3','290')
			, '4'=>array('25','210')
			, '5'=>array('20','170')
			, '6'=>array('16.6','145')
		);
		if (isset($opt[$arg['grid']])) {
			$buff = '';
			$o = $opt[$arg['grid']];
			for ($i=0; $i < (int)$arg['grid']; ++$i) {
				 $buff .= "<div class='plugin-calendar-grid'>".frame_renderer(__calendar_renderer($page_ar, $arg))."</div>";
				 $arg['handle']=false;
			}
$tmp = <<<EOT
			<style>
			.plugin-calendar-grid {
				width:{$o[0]}%;
				display:inline-block;
				min-width:{$o[1]}px;
			}
			.plugin-calendar-grid .plugin-calendar {
				padding:5px 5px 10px 0;
			}
			</style>
EOT;
			$html['css']['plugin-calendar-grid'] = $tmp;
			return $buff;
		}
	}
	return frame_renderer(__calendar_renderer($page_ar, $arg));
}
function __calendar_renderer( &$page_ar , &$arg )
{
	global $database,$params,$ut,$plugin_ar;
	global $html;
	
	$buff = '';
	//設定読み込み
	$base_link=$page_ar['id'];
	if (!empty($arg['page'])) {
		if ($arg['page'] == 'top') {
			$arg['page'] = (int)$params['circle']['meta']['top_page'];
		}
		$base_link=$arg['page'];
	}
	$meta = array();
	$p_id = 0;
	$sql = "select id, att, metadata from ".DBX."user_log where att=0 and type=? and link=? ";
	$ar = $database->sql_select_all($sql, CALENDAR_ID, $base_link);
	if ($ar) {
		$meta = unserialize64($ar[0]['metadata']);
		$p_id = $ar[0]['id'];
	}
	if (empty($meta['colorset'])) {
		$meta['colorset'] = array();
		$meta['colorset'][] = array('text'=>'', 'bk'=>'#FC7708', 'fr'=>'#000','mark'=>'定休日');
		$meta['colorset'][] = array('text'=>'', 'bk'=>'#fa3152', 'fr'=>'#000', 'mark'=>'x');
		$meta['colorset'][] = array('text'=>'', 'bk'=>'#9FB6FF', 'fr'=>'#000','mark'=>'o');
		$meta['colorset'][] = array('text'=>'', 'bk'=>'#FF8C8C', 'fr'=>'#000','mark'=>'');
		$meta['colorset'][] = array('text'=>'', 'bk'=>'#FFCC5F', 'fr'=>'#000','mark'=>'');
	}
	if (empty($meta['width'])) {
		$meta['width'] = '';
	}
	if (empty($meta['height'])) {
		$meta['height'] = "80px";
	}
	if (empty($meta['font_size'])) {
		$meta['font_size'] = "14px";
	}
	if (!empty($params['plugin']['calendar']['time'])) {
		$date = $params['plugin']['calendar']['time'];
	} else {
		$params['plugin']['calendar']['time'] = $date = time();
	}
	

	$first_day = strtotime("first day of",$date);
	$d_ind = date("Y-m-01 00:00:00",$first_day);
	
	$w = '14.28%';
	if ($meta['width']) {
		$w = $meta['width'];
	}

	//CSS設定
$tmp = <<<EOT
	<style>
	.plugin-calendar {
		padding:0 0 20px 0;
		font-size:{$meta['font_size']};
	}
	.plugin-calendar table {
		padding-bottom:10px;
		border-collapse: collapse;
		border-spacing: 0;
		width:100%;
	}
	.plugin-calendar td, .plugin-calendar th {
		text-align: center;
		border:1px solid #c0c0c0;
		vertical-align: top;
		width:$w;
		overflow:hidden;
		position:relative;
		border:none;
	}
	.plugin-calendar th {
		background-color:#c0c0c0;
		min-height:2em;
	}
	.plugin-calendar td {
	}
	.plugin-calendar .cnum p {
		padding: 2px 0;
EOT;
		if (!$meta['width']) {
$tmp .= <<<EOT
			width:100px;
			display:none;
EOT;
		}
$tmp .= <<<EOT
		height:1em;
		line-height:1.5em;
	}
	.plugin-calendar td div {
	}
	.plugin-calendar td .cnum {
		border:1px solid #c0c0c0;
		border-width:0 0 1px 1px;
		height:{$meta['height']};
		overflow:hidden;
	}
	.plugin-calendar td select,.plugin-calendar td input {
		color:#000;
		font-size:14px;
	}
	.plugin-calendar tr td:last-child .cnum {
		border-width:0 1px 1px 1px;
	}
	.plugin-calendar tr td .setting_mode {
		height:100px;
	}
	.plugin-calendar .holiday_ind {
		padding: 2px 10px;
		min-width: 76px;
		display: inline-block;
		text-align: center;
		margin: 5px 5px 5px 0;
		cursor:pointer;
	}
	</style>
EOT;
	$html['css']['plugin-calendar'] = $tmp;

	$hnd = !isset($arg['handle']) || $arg['handle']=false;
	
	if (!$meta['width']) {
$html['meta']['plugin-calendar-js1'] = <<<EOT
		<script>
		\$(function(){
			ot.plugin_calendar_onresize = function() {
				var obj = \$('.plugin-calendar');
				var w = obj.width();
				if (!ot.plugin_calendar_width || ot.plugin_calendar_width - 10 > w || ot.plugin_calendar_width  + 10 < w) {
					ot.plugin_calendar_width = w;
					obj.each(function(){
						var o = \$(this);
						w = o.width();
						var f = parseInt(w/(7*5));
						if (f > 14) {f = 14;}
						o.find('td .cnum p').css({'font-size':f+'px','width':parseInt(w/7)+'px'}).show();
					});
				}
			}
			\$(window).on('resize', function(){
				ot.plugin_calendar_onresize();
			});
			ot.plugin_calendar_onresize();
		});
		</script>
EOT;
	}

	if (!check_rights('edit')) {
		$buff .= "<div class='plugin-calendar'>";
		$buff .= draw_plugin_calendar($date,$first_day, $page_ar, $meta, $arg);
		$buff .= "</div>";

	} else {

		$menu = '';
		if (!isset($_SESSION['plugin_calendar_mode'])) {
			if ($hnd) {
$menu .= <<<EOT
				<a href='javascript:void(ot.change_plugin_calendar_mode(1))' class='onethird-button mini' >day setting</a>
				</a>
EOT;
			}
			$buff .= "<div class='plugin-calendar'>";
			$buff .= draw_plugin_calendar($date,$first_day, $page_ar, $meta, $arg);
			$buff .= "</div>";

		} else {

			ajax_plugin_calendar_holiday($page_ar,$meta,$base_link);
			$buff .= "<div class='plugin-calendar'>";
			$buff .= draw_plugin_calendar($date,$first_day, $page_ar, $meta, $arg, 'holiday');
			$buff .= "</div>";
$menu .= <<<EOT
			<a href='javascript:void(ot.delete_plugin_calendar_holiday())' class='onethird-button mini' >remove data</a>
			</a>
			<a href='javascript:void(ot.save_plugin_calendar_holiday())' class='onethird-button mini' >save</a>
			<a href='javascript:void(ot.change_plugin_calendar_mode(0))' class='onethird-button mini' >exit</a>
EOT;
		}

		if (isset($_POST['ajax']) && $_POST['ajax'] == 'change_plugin_calendar_mode')  {
			$r = array();
			$r['result'] = true;
			$mode = 0;
			if (isset($_POST['mode'])) {
				$mode = (int)$_POST['mode'];
			}
			if ($mode) {
				$_SESSION['plugin_calendar_mode'] = $mode;
			} else {
				unset($_SESSION['plugin_calendar_mode']);
			}
			echo( json_encode($r) );
			exit();
		}

		if (isset($_POST['ajax']) && $_POST['ajax'] == 'delete_plugin_calendar_holiday')  {
			$r = array();
			if ($database->sql_update("delete from ".DBX."user_log where att=0 and type=? and link=? ", CALENDAR_ID, $base_link)) {
				$r['result'] = true;
			}
			echo( json_encode($r) );
			exit();
		}

$tmp = <<<EOT
		<script>
		ot.delete_plugin_calendar_holiday = function() {
			if (!confirm('Are you sure you want to delete data?')) {
				return;
			}
			ot.ajax({
				type: "POST"
				, url: '{$params['safe_request']}'
				, data: "ajax=delete_plugin_calendar_holiday"
				, dataType:'json'
				, success: function(data) {
					location.reload(true);
				}
			});
		};
		ot.change_plugin_calendar_mode = function(a) {
			ot.ajax({
				type: "POST"
				, url: '{$params['safe_request']}'
				, data: "ajax=change_plugin_calendar_mode&mode="+a
				, dataType:'json'
				, success: function(data) {
					location.reload(true);
				}
			});
		};
		ot.save_plugin_calendar_setting = function() {
			var a = \$('#plugin_calendar_setting #p_resrv_count').val();
			ot.ajax({
				type: "POST"
				, url: '{$params['safe_request']}'
				, data: "ajax=save_plugin_calendar_setting&p_resrv_count="+a
				, dataType:'json'
				, success: function(data) {
					location.reload(true);
				}
			});
		};
		ot.calendar_color = function (e) {
			ot.calendar_color_id = e;
			\$('#color_dialog .ok_btn').val('OK').unbind().click(function(){
				\$('#'+ot.calendar_color_id).val(\$('#color_dialog .color').text());
				\$('#color_dialog').remove();
			});
		}; 
		</script>
EOT;
		$html['meta']['plugin-calendar-js2'] = $tmp;

		if (!isset($_SESSION['plugin_calendar_mode']) && $hnd) {
			$menu .= std_blockmenu_renderer($page_ar);
		}
		if ($hnd) {
$menu .= <<<EOT
			<a href='javascript:void(ot.page_calendar_setting({$page_ar['id']}))' >{$ut->icon('setting')}</a>
EOT;
		}
		if ($menu) {
			$buff .= "<div class='edit_pointer'>$menu</div>";
		}

		// 設定
		snippet_std_setting("Calendar setting","page_calendar_setting");
		snippet_colorpicker($page_ar);
		if (isset($_POST['ajax']) && $_POST['ajax'] == "page_calendar_setting")  {
			if ($page_ar['id'] == (int)$_POST['id']) {
				$r = array();
				$r['result'] = true;
				$r['id'] = $page_ar['id'];
				$r['meta'] = $meta;
				$grid = '';
				if (!empty($page_ar['meta']['plugin_calendar_grid'])) {
					$grid = $page_ar['meta']['plugin_calendar_grid'];
				}

$r['html'] = <<<EOT
				<table>
EOT;
				$i=0;
				foreach ($meta['colorset'] as $v) {
					++$i;
$r['html'] .= <<<EOT
					<tr>
						<td >
							<div style='vertical-align: top;color:{$v['fr']};background-color:{$v['bk']};padding:5px 20px;margin:5px' id='colorset_td_{$i}'>
								Color{$i}
							</div>
						</td>
						<td>
							<span style='padding-left:10px'>text <input type='text' data-input='colorset_text_{$i}' value='{$v['text']}' style='width:100px' /></span>
							<span style='padding-left:10px'>mark <input type='text' data-input='colorset_mark_{$i}' value='{$v['mark']}' style='width:100px' /></span>
							<span style='padding-left:10px'>
								<input type='button'  value='back-color' class='onethird-button mini' onclick="ot.open_color_dialog({page:'top',selector:'#colorset_td_{$i}' ,type:'background', value:'{$v['bk']}',onready:function(){ot.calendar_color('colorset_bk_{$i}')}  })" />
							<input type='text' id='colorset_bk_{$i}' data-input='colorset_bk_{$i}' value='{$v['bk']}' style='width:100px' /></span>
							<span style='padding-left:10px'>
								<input type='button' value='text-color' class='onethird-button mini' onclick="ot.open_color_dialog({page:'top',selector:'#colorset_td_{$i}' ,value:'{$v['fr']}', value:'{$v['bk']}',onready:function(){ot.calendar_color('colorset_fr_{$i}')} })" />
							<input type='text' id='colorset_fr_{$i}'  data-input='colorset_fr_{$i}' value='{$v['fr']}' style='width:100px' /></span>
						</td>
					</tr>
EOT;
				}
$r['html'] .= <<<EOT
					<tr>
						<td style='vertical-align: top;'>Option</td>
						<td>
							<span style='display: inline-block;'>width</span><input type='text' data-input='page_calendar_width' value='{$ut->safe_echo($meta['width'])}' style='width:5em;margin:0 2em 0 1em;' placeholder='auto' />
							<span style='display: inline-block;'>height</span><input type='text' data-input='page_calendar_height' value='{$ut->safe_echo($meta['height'])}' style='width:5em;margin:0 2em 0 1em;' />
							<span style='display: inline-block;'>font-size</span><input type='text' data-input='page_calendar_font_size' value='{$ut->safe_echo($meta['font_size'])}' style='width:5em;margin:0 2em 0 1em;' />
							<span style='display: inline-block;'>grid</span><input type='text' data-input='plugin_calendar_grid' value='{$ut->safe_echo($grid)}' style='width:5em;margin:0 2em 0 1em;' placeholder='default' />
						</td>
					</tr>
				</table>
EOT;
				echo(json_encode($r));
				exit();
			}
		}
		if (check_rights('admin') && isset($_POST['ajax']) && $_POST['ajax'] == 'save_page_calendar_setting')  {
			if ($page_ar['id'] == (int)$_POST['id']) {
				$r = array();
				$r['result'] = false;

				$i=0;
				foreach ($meta['colorset'] as &$v) {
					++$i;
					if (isset($_POST["colorset_text_{$i}"])) { $v['text'] = sanitize_str($_POST["colorset_text_{$i}"]); }
					if (isset($_POST["colorset_mark_{$i}"])) { $v['mark'] = sanitize_str($_POST["colorset_mark_{$i}"]); }
					if (isset($_POST["colorset_bk_{$i}"])) { $v['bk'] = sanitize_str($_POST["colorset_bk_{$i}"]); }
					if (isset($_POST["colorset_fr_{$i}"])) { $v['fr'] = sanitize_str($_POST["colorset_fr_{$i}"]); }
				}
				unset($v);
				if (!empty($_POST['page_calendar_font_size'])) {
					$meta['font_size'] = sanitize_asc($_POST['page_calendar_font_size']);
				} else {
					unset($meta['font_size']);
				}
				if (!empty($_POST['page_calendar_height'])) {
					$meta['height'] = sanitize_asc($_POST['page_calendar_height']);
				} else {
					unset($meta['height']);
				}
				if (!empty($_POST['page_calendar_width'])) {
					$meta['width'] = sanitize_asc($_POST['page_calendar_width']);
				} else {
					unset($meta['width']);
				}
				if ($p_id == 0) {
					$x = array();
					$x['link'] = $base_link;
					$x['type'] = CALENDAR_ID;
					if (!add_user_log($x)) {
						echo(json_encode($r));
						exit();
					}
					$p_id = $x['id'];
				}
				$r['id'] = $p_id;
				$r['meta'] = $meta;
				$r['items'] = array();
				$r['metadata'] = serialize64($r['meta']);
				$r['result'] = mod_user_log($r);
				
				if ($r['result']) {
					if (!empty($_POST['plugin_calendar_grid'])) {
						$page_ar['meta']['plugin_calendar_grid'] = sanitize_num($_POST['plugin_calendar_grid']);
					} else {
						unset($page_ar['meta']['plugin_calendar_grid']);
					}
					$page_ar['metadata'] = serialize64($page_ar['meta']);
					$r['result'] = mod_data_items($page_ar);
				}
				echo(json_encode($r));
				exit();
			}
		}
	}

	//ポインターを次の月に進める
	$params['plugin']['calendar']['time'] = strtotime("+1 month",$first_day);

	return $buff;
}

function ajax_plugin_calendar_holiday(&$page_ar,$meta,$base_link)
{
	global $database,$params,$p_circle,$config, $html, $plugin_ar, $ut;

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_plugin_calendar_holiday')  {
		$r = array();
		$r['result'] = false;
		$ar = explode(',',sanitize_str($_POST['data']));
		$item = array();
		foreach ($ar as $v) {
			if ($v) {
				$v = explode(':',$v);
				if (count($v) == 3) {
					$x = array();
					if ($v[1]) { $x['c'] = (int)$v[1]-1; }
					if ($v[2]) { $x['t'] = $v[2]; }
					$item[$v[0]] = $x;
				}
			}
		}
		$ar = $database->sql_select_all("select id, att, metadata from ".DBX."user_log where att=0 and type=? and link=? ", CALENDAR_ID, $base_link);
		if (!$ar) {
			$x = array();
			$x['link'] = $base_link;
			$x['type'] = CALENDAR_ID;
			if (!add_user_log($x)) {
				echo( json_encode($r) );
				exit();
			}
			$ar = $database->sql_select_all("select id, att, metadata from ".DBX."user_log where att=0 and type=? and link=? ", CALENDAR_ID, $base_link);
		}
		if ($ar) {
			$x = array();
			$x['id'] = $ar[0]['id'];
			$r['page_ar'] = $page_ar;
			$x['meta'] = unserialize64($ar[0]['metadata']);
			$r['items'] = $x['meta']['items'] = $item;
			$r['x'] = $x;
			$x['metadata'] = serialize64($x['meta']);
			$r['result'] = mod_user_log($x);
		}
		unset($_SESSION['plugin_calendar_mode']);
		echo( json_encode($r) );
		exit();
	}
	$x = json_encode($meta['colorset']);
$tmp = <<<EOT
	<script>
	ot.click_plugin_calendar_holiday = function(obj) {
		var obj = \$(obj);
		var holiday_ar = $x;
		var x = obj.val()-1;
		if (x<0) {
			obj.parent().css('background-color','inherit');
		} else {
			obj.parent().css('background-color',holiday_ar[x].bk);
		}
	};

	ot.save_plugin_calendar_holiday = function() {
		var a = '';
		\$('.calendar-unit .cnum').each(function(){
			var o = \$(this);
			var x1 = o.find('select');
			if (x1.length) {
				var x1 = x1.val();
				var x2 = o.find('input').val();
				if (parseInt(x1) || x2) {
					a += o.attr('data-x') + ':' + x1 +':' + x2 +",";
				}
			}
		});
		ot.ajax({
			type: "POST"
			, url: '{$params['safe_request']}'
			, data: "ajax=save_plugin_calendar_holiday&data="+a
			, dataType:'json'
			, success: function(data) {
				if (data['result']) {
					location.reload(true);
				}
			}
		});
	};
	</script>
EOT;
	$html['meta']['plugin-calendar-js3'] = $tmp;
}

function draw_plugin_calendar($now, $first_day, &$page_ar, &$meta, &$arg, $mode='')
{
	global $database,$params,$p_circle,$config,$ut;
	
	$buff = '';
	
	$week_ar = explode(',','日,月,火,水,木,金,土');

	$date_m  = date("m",$now);
	$date_y  = date("Y",$now);
	$now_day = time();
	$next_month = strtotime("+ 1 month",$first_day);
	$d = date("w", $first_day);
	$len = ($next_month-$first_day)/(60*60*24);

	$mn  = date("n",$now);
	$setting_mode = '';
	if ($mode == 'holiday') {
		$setting_mode = ' setting_mode ';
	}

$buff .=  <<<EOT
	<h2 class='title'>
		{$mn}月
	</h2>
	<div>
EOT;
	$i=0;
	foreach ($meta['colorset'] as $v) {
		$s = "background-color: {$v['bk']};";
		if (isset($v['fr'])) {
			$s .= "color: {$v['fr']};";
		}
		$t = $v['text'];
		if ($mode == 'holiday') {
			++$i;
			if (!empty($v['text'])) {
				$t = $i.": {$v['text']}";
			} else if ($v['mark']) {
				$t = $i.": {$v['mark']}";
			} else {
				$t = $i;
			}
		} else {
			if (empty($v['text']) || !empty($v['mark'])) {
				continue;
			}
		}
$buff .=  <<<EOT
		<span class='holiday_ind' style='$s' >{$t}</span>
EOT;
	}
$buff .=  <<<EOT
	</div>
	<table class='calendar-unit'  >
	<tr>
EOT;
	foreach ($week_ar as $item) {
$buff .=  <<<EOT
		<th>$item</th>
EOT;
	}
$buff .=  <<<EOT
	</tr>
	<tr>
EOT;
	$row = 0;
	for ($i=0,$x=1-$d; $len > 0; ++$i) {
		if ($x>0) {
$buff .= <<<EOT
			<td >
EOT;
			$dxx = "{$date_y}/{$date_m}/".sprintf("%02d",$x);
			$cx = '';
			$ind = '<br />';
			$j = false;
			$t = '';
			$c = '';
			if (isset($meta['items'][$dxx])) {
				$c = $meta['items'][$dxx];
				if (is_array($c)) {
					$t = (isset($c['t']))? "{$c['t']}":'';
					$c = (isset($c['c']))? $c['c']:'';
				}
				if (isset($meta['colorset'][$c])) {
					if (!empty($meta['colorset'][$c]['mark'])) {
						$ind = "<p>".$meta['colorset'][$c]['mark']."</p>";
					}
					$d = (int)$c+1;
					$cx = " data-color='$d' style='background-color:{$meta['colorset'][$c]['bk']}; ";
					if (isset($meta['colorset'][$c]['fr'])) {
						$cx .= " color: {$meta['colorset'][$c]['fr']};";
						$j = $c+1;
					}
					if (isset($meta['colorset'][$c]['note'])) {
						$t = $meta['colorset'][$c]['note'];
					}
					$cx .= " ' ";
				}
			}
			if ($mode == 'holiday') {
$buff .= <<<EOT
				<div class='cnum $setting_mode' data-x='$dxx' $cx>
					<div>$x</div>
					<div><input type='text' value='{$ut->safe_echo($t)}' style='width:3em;' /></div>
					<select onchange='ot.click_plugin_calendar_holiday(this)' > 
						<option value='0'>--</option>
EOT;
						$k=0;
						foreach ($meta['colorset'] as $v) {
							$s = '';
							++$k;
							if ($j && $k==$j) {$s = ' selected '; }
$buff .= <<<EOT
							<option value='$k' $s>$k</option>
EOT;
						}
$buff .= <<<EOT
					</select>
				</div>
EOT;
			} else {
				if ($t) {
					$t = "<p>$t</p>";
					$ind = '';
				}
				if ($c === '') {
					$c = 0;
				} else {
					$c = (int)$c+1;
				}
				if (!empty($params['plugin']['calendar']["day_str{$c}"])) {
					$t .= $params['plugin']['calendar']["day_str{$c}"];
				}
				$buff .= "<div class='cnum $setting_mode' $cx data-date='$dxx' >$x $t $ind </div>";
			}
			
			$buff .= ("</td>");
			--$len;
		} else {
			$buff .= ("<td><div class='cnum $setting_mode' >&nbsp;</div></td>");
		}
		if ($i >= 6) {
			$i=-1;
			$buff .= ("</tr>\n<tr>");
			++$row;
		}
		++$x;
	}
	while ($i!=0 && $i++ < 7) {
		$buff .= ("<td><div class='cnum $setting_mode' >&nbsp;</div></td>");
	}
	if (!empty($arg['full-row']) && $row==4) {
		$buff .=  "<tr>";
		for ($i=0; $i<7; ++$i) {
			$buff .= "<td><div class='cnum $setting_mode' >&nbsp;</div></td>";
		}
		$buff .=  "</tr>";
	}
$buff .=  <<<EOT
	</tr>
	</table>
EOT;
	return $buff;
}

?>